/****************************************************************************/
/*  File:       LoggingOutputStream.java                                    */
/*  Author:     F. Georges - fgeorges.org                                   */
/*  Date:       2009-02-22                                                  */
/*  Tags:                                                                   */
/*      Copyright (c) 2009 Florent Georges (see end of file.)               */
/* ------------------------------------------------------------------------ */


package tmp.tests;

import java.io.IOException;
import java.io.OutputStream;

/**
 * TODO<doc>: ...
 *
 * @author Florent Georges
 * @date   2009-02-22
 */
public class LoggingOutputStream
        extends OutputStream
{
    public LoggingOutputStream(OutputStream proxied) {
        myProxied = proxied;
    }
    @Override
    public void write(int b) throws IOException {
        System.err.println("LOS: write(int): " + (char) b);
        myProxied.write(b);
    }
    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        System.err.println("LOS: write(byte[],int,int): " + new String(b, off, len));
        myProxied.write(b, off, len);
    }
    @Override
    public void write(byte[] b) throws IOException {
        System.err.println("LOS: write(byte[]): " + new String(b));
        myProxied.write(b);
    }
    @Override
    public void flush() throws IOException {
        System.err.println("LOS: flush()");
        myProxied.flush();
    }
    @Override
    public void close() throws IOException {
        System.err.println("LOS: close()");
        myProxied.close();
    }
    private OutputStream myProxied;
}


/* ------------------------------------------------------------------------ */
/*  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS COMMENT.               */
/*                                                                          */
/*  The contents of this file are subject to the Mozilla Public License     */
/*  Version 1.0 (the "License"); you may not use this file except in        */
/*  compliance with the License. You may obtain a copy of the License at    */
/*  http://www.mozilla.org/MPL/.                                            */
/*                                                                          */
/*  Software distributed under the License is distributed on an "AS IS"     */
/*  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See    */
/*  the License for the specific language governing rights and limitations  */
/*  under the License.                                                      */
/*                                                                          */
/*  The Original Code is: all this file.                                    */
/*                                                                          */
/*  The Initial Developer of the Original Code is Florent Georges.          */
/*                                                                          */
/*  Contributor(s): none.                                                   */
/* ------------------------------------------------------------------------ */
